﻿try{
 var xmlHttp = new XMLHttpRequest();
}
catch (e){
 var xmlHttp = new ActiveXObject('Microsoft.XMLHTTP');
}

var fso = new ActiveXObject("Scripting.FileSystemObject");
var wshShell = new ActiveXObject("WScript.Shell");

System.Gadget.settingsUI = "Settings.html";
System.Gadget.onSettingsClosed = settingsClose;

document.onselectstart = function() {return false};

var LocationIDCode;
var size;
var pixprefiks;
var factheight;
var timervar;
var refreshRate;
var timewaitforrun;
var waitforruntime;
var updateTimerId;
var firstupdatetimer;
var updaterperiod = (Math.floor(Math.random() * (50 - 30 + 1)) + 30) * 1000; //random value between 30 and 50 sec
var temperatureformat;
var speedformat;
var pressureformat;
var distanceformat;
var timeformat;
var precformat;
var dateformat;
var adjustlastupdtime;
var adjustsuntime;
var adjustastronomytime;
var autoscaleDPIflag;
var autoupdateflag;
var hidetitleflag;
var hidestateflag;
var hidelocationflag;
var hidepressureflag;
var hidehumidityflag;
var hidevisibilityflag;
var hideuvindexflag;
var hidewindflag;
var hideprecipitationflag;
var hidesunflag;
var hidemoonflag;
var hideupdatedflag;
var hidecopyrightflag;
var disableflyoutsoundsflag;
var savedisksflag;
var icontype;
var w10err;
var int_Counter;
var firstconnectflag;
var imperialsystemusaflag;

var obsdate = new Array;
var daycode = new Array;
var fsunrise = new Array;
var fsunset = new Array;
var dtext = new Array;
var dwicon = new Array;
var dhtemp = new Array;
var dltemp = new Array;
var dhrftemp = new Array;
var dlrftemp = new Array;
var dwindspd = new Array;
var dwinddir = new Array;
var dmaxuv = new Array;
var ntext = new Array;
var nwicon = new Array;
var nhtemp = new Array;
var nltemp = new Array;
var nhrftemp = new Array;
var nlrftemp = new Array;
var nwindspd = new Array;
var nwinddir = new Array;
var astronomy = new Array;

//color settings
var cBgColor;
var cTitle;
var cTemperature;
var cLocation;
var cRealFeel;
var cPressure;
var cHumidity;
var cVisibility;
var cUVindex;
var cWind;
var cPrecipitation;
var cSunrise;
var cSunset;
var cMoonPhase;
var cLastupdate;
var cLegend;
var cError;
var cCopyright;
var cVersion;

var updateavailable;
var showupdate;

function CheckUpdates(){
 if (!updateavailable) autoupdate();

 if (updateavailable && !showupdate){
  autoapdater.style.top = parseInt((factheight - 8) * size);
  factheight += 12;
  document.body.style.height = parseInt(factheight * size);
  background.style.height = parseInt(factheight * size);
  mainsquare.style.height = parseInt((factheight - 10) * size);
  autoapdater.style.display = "block";
  showupdate = true;
 }

 updateTimerId = setTimeout("CheckUpdates()", 86400000);// Update once a day
}

function autoupdate(){
 var url = "https://windows10gadgets.pro/versioninfo/WeatherMonitorversioninfo.xml";
 xmlHttp.open("GET", url, false); //false mean call is synchronous
 xmlHttp.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT"); //for non cached
 xmlHttp.send(null);
 if (xmlHttp.readyState == 4 && xmlHttp.status == 200){
  var newVersion = xmlHttp.responseXML.getElementsByTagName("version")[0].firstChild.nodeValue;
  var updateUrl = xmlHttp.responseXML.getElementsByTagName("url")[0].firstChild.nodeValue;
  // Compare and show message if a newer version is available.
  if (parseFloat(newVersion) > parseFloat(System.Gadget.version)){
   autoapdater.innerHTML = "<a id='ulink' href='" + updateUrl + "' style='text-decoration:none;color:" + cLegend +
   "' onclick='System.Gadget.close()' onmouseout='ulink.style.textDecoration=" + '"none"' + "' onmouseover='ulink.style.textDecoration=" +
   + '"underline"' + "'>Version <strong>" + newVersion + "</strong> is available!</a>";
   updateavailable = true;
  }// if
 }// if
}

function CountDown(){
 document.getElementById('timecounter').innerText = waitforruntime.toFixed(1);
 if (waitforruntime) timewaitforrun = setTimeout('CountDown()',100);
 else{
  clearTimeout(timewaitforrun);
  hideifnoconnect.style.display = "block";
  waitforrunstr.style.display = "none";
  getweather();
 }
 waitforruntime = parseInt((waitforruntime - 0.1) * 10) / 10;
}

function init(){
 w10err = 0; //Important
 firstconnectflag = true; //Important
 loadsettingsfromfile(); //don't move this line!!!
 loadSettings();
 if (autoscaleDPIflag) getDPIsize(); //Important!!! After loadsettings()
 setupgadget();
 background.style.display = "block";
 if (!waitforruntime) getweather();
 else{
  hideifnoconnect.style.display = "none";
  waitforrunstr.style.display = "block";
  CountDown();
 }
 updateavailable = false;
 showupdate = false;
 if (autoupdateflag) firstupdatetimer = setTimeout("CheckUpdates()", updaterperiod);
}

function settingsClose(){
 clearTimeout(timervar);
 clearTimeout(timewaitforrun);
 w10err = 0; //Important
 firstconnectflag = true; //Important
 waitforrunstr.style.display = "none";
 loadSettings();
 if (autoscaleDPIflag) getDPIsize(); //Important!!! After loadsettings()
 setupgadget();
 getweather();
 if (autoupdateflag){
  if (autoapdater.innerHTML == "") firstupdatetimer = setTimeout("CheckUpdates()", updaterperiod);
  else{
   autoapdater.style.top = parseInt((factheight - 8) * size);
   factheight += 12;
   document.body.style.height = parseInt(factheight * size);
   background.style.height = parseInt(factheight * size);
   mainsquare.style.height = parseInt((factheight - 10) * size);
   autoapdater.style.display = "block";
  }
 }
 else{
  clearTimeout(firstupdatetimer);
  clearTimeout(updateTimerId);
 }
}

function getDPIsize(){
 try{
  var getdefaultDPI = wshShell.RegRead("HKCU\\Control Panel\\Desktop\\LogPixels");
  size = parseInt((getdefaultDPI / 96) * 100) / 100;
  System.Gadget.Settings.write("SetSize", size);
 }
 catch (e){}
}

function loadsettingsfromfile(){
 var fs = new ActiveXObject("Scripting.FileSystemObject");
 var inifilename = System.Environment.getEnvironmentVariable("APPDATA") + "\\" + System.Gadget.name + "_Settings.ini";
 try{
  var inifile = fs.OpenTextFile(inifilename, 1); //1 read
   try{
    var tmp = inifile.ReadLine();
    tmp = inifile.ReadLine();
    if (tmp != ";meow") throw "old";

    savedisksflag = inifile.ReadLine();
    System.Gadget.Settings.write ("SaveCitytoDisks", savedisksflag);
    LocationIDCode = inifile.ReadLine();
    if (savedisksflag == "false"){//Warning!!! Don't change this line
     System.Gadget.Settings.write("LocationIDCode", LocationIDCode);
    }

    //color settings
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sBgColorSelect", tmp);
    cBgColor = inifile.ReadLine();
    System.Gadget.Settings.write("colBgColor", cBgColor);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sTitColorSelect", tmp);
    cTitle = inifile.ReadLine();
    System.Gadget.Settings.write("colTitle", cTitle);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sCurrentTColorSelect", tmp);
    cTemperature = inifile.ReadLine();
    System.Gadget.Settings.write("colTemperature", cTemperature);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sLocationColorSelect", tmp);
    cLocation = inifile.ReadLine();
    System.Gadget.Settings.write("colLocation", cLocation);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sRealFeelColorSelect", tmp);
    cRealFeel = inifile.ReadLine();
    System.Gadget.Settings.write("colRealFeel", cRealFeel);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sPressureColorSelect", tmp);
    cPressure = inifile.ReadLine();
    System.Gadget.Settings.write("colPressure", cPressure);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sHumidityColorSelect", tmp);
    cHumidity = inifile.ReadLine();
    System.Gadget.Settings.write("colHumidity", cHumidity);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sVisibilityColorSelect", tmp);
    cVisibility= inifile.ReadLine();
    System.Gadget.Settings.write("colVisibility", cVisibility);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sUVindexColorSelect", tmp);
    cUVindex = inifile.ReadLine();
    System.Gadget.Settings.write("colUVindex", cUVindex);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sWindColorSelect", tmp);
    cWind = inifile.ReadLine();
    System.Gadget.Settings.write("colWind", cWind);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sPrecipitationColorSelect", tmp);
    cPrecipitation = inifile.ReadLine();
    System.Gadget.Settings.write("colPrecipitation", cPrecipitation);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sSunriseColorSelect", tmp);
    cSunrise = inifile.ReadLine();
    System.Gadget.Settings.write("colSunrise", cSunrise);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sSunsetColorSelect", tmp);
    cSunset = inifile.ReadLine();
    System.Gadget.Settings.write("colSunset", cSunset);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sMoonPhaseColorSelect", tmp);
    cMoonPhase = inifile.ReadLine();
    System.Gadget.Settings.write("colMoonPhase", cMoonPhase);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sLastupdateColorSelect", tmp);
    cLastupdate = inifile.ReadLine();
    System.Gadget.Settings.write("colLastupdate", cLastupdate);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sLegendColorSelect", tmp);
    cLegend = inifile.ReadLine();
    System.Gadget.Settings.write("colLegend", cLegend);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sErrorColorSelect", tmp);
    cError = inifile.ReadLine();
    System.Gadget.Settings.write("colError", cError);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sVersnColorSelect", tmp);
    cVersion = inifile.ReadLine();
    System.Gadget.Settings.write("colVersion", cVersion);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sCopyColorSelect", tmp);
    cCopyright = inifile.ReadLine();
    System.Gadget.Settings.write("colCopyright", cCopyright);
    //color settings end

    size = inifile.ReadLine();
    System.Gadget.Settings.write("SetSize", size);
    refreshRate = inifile.ReadLine();
    System.Gadget.Settings.write("refreshtime", refreshRate);
    temperatureformat = inifile.ReadLine();
    System.Gadget.Settings.write("TemperatureFormat", temperatureformat);
    speedformat = inifile.ReadLine();
    System.Gadget.Settings.write("SpeedFormat", speedformat);
    pressureformat = inifile.ReadLine();
    System.Gadget.Settings.write("PressureFormat", pressureformat);
    distanceformat = inifile.ReadLine();
    System.Gadget.Settings.write("DistanceFormat", distanceformat);
    timeformat = inifile.ReadLine();
    System.Gadget.Settings.write("TimeFormat", timeformat);
    autoscaleDPIflag = inifile.ReadLine();
    System.Gadget.Settings.write ("DPIautoscale", autoscaleDPIflag);
    autoupdateflag = inifile.ReadLine();
    System.Gadget.Settings.write ("AutoUpdate", autoupdateflag);
    hidestateflag = inifile.ReadLine();
    System.Gadget.Settings.write ("StateHide", hidestateflag);
    hidetitleflag = inifile.ReadLine();
    System.Gadget.Settings.write ("TitleHide", hidetitleflag);
    hidecopyrightflag = inifile.ReadLine();
    System.Gadget.Settings.write ("CopyrightHide", hidecopyrightflag);
    disableflyoutsoundsflag = inifile.ReadLine();
    System.Gadget.Settings.write ("DisableFlyoutSounds", disableflyoutsoundsflag);
    precformat = inifile.ReadLine();
    System.Gadget.Settings.write("PrecipitationFormat", precformat);
    icontype = inifile.ReadLine();
    System.Gadget.Settings.write("IconType", icontype);
    dateformat = inifile.ReadLine();
    System.Gadget.Settings.write("DateFormat", dateformat);
    hidelocationflag = inifile.ReadLine();
    System.Gadget.Settings.write ("LocationHide", hidelocationflag);
    hidepressureflag = inifile.ReadLine();
    System.Gadget.Settings.write ("PressureHide", hidepressureflag);
    hidehumidityflag = inifile.ReadLine();
    System.Gadget.Settings.write ("HumidityHide", hidehumidityflag);
    hidevisibilityflag = inifile.ReadLine();
    System.Gadget.Settings.write ("VisibilityHide", hidevisibilityflag);
    hideuvindexflag = inifile.ReadLine();
    System.Gadget.Settings.write ("UVindexHide", hideuvindexflag);
    hidewindflag = inifile.ReadLine();
    System.Gadget.Settings.write ("WindHide", hidewindflag);
    hideprecipitationflag = inifile.ReadLine();
    System.Gadget.Settings.write ("PrecipitationHide", hideprecipitationflag);
    hidesunflag = inifile.ReadLine();
    System.Gadget.Settings.write ("SunHide", hidesunflag);
    hidemoonflag = inifile.ReadLine();
    System.Gadget.Settings.write ("MoonHide", hidemoonflag);
    hideupdatedflag = inifile.ReadLine();
    System.Gadget.Settings.write ("UpdatedHide", hideupdatedflag);
    waitforruntime = inifile.ReadLine();
    System.Gadget.Settings.write("WaitingTime", waitforruntime);
    imperialsystemusaflag = inifile.ReadLine();
    System.Gadget.Settings.write("ImperialSystemUSA", imperialsystemusaflag);
    adjustlastupdtime = inifile.ReadLine();
    System.Gadget.Settings.write("AdjustLastUpdateTime", adjustlastupdtime);
    adjustsuntime = inifile.ReadLine();
    System.Gadget.Settings.write("AdjustSunTime", adjustsuntime);
    adjustastronomytime = inifile.ReadLine();
    System.Gadget.Settings.write("AdjustAstronomyTime", adjustastronomytime);
  }//end try 2
  
   finally {inifile.Close()}
 }//end try 1
 
 catch (e){}

 finally {fs = null}
}

function loadSettings(){
 savedisksflag = System.Gadget.Settings.read ("SaveCitytoDisks");
 if (savedisksflag != "true"){
  savedisksflag = false;
  System.Gadget.Settings.write ("SaveCitytoDisks", "false");
 }
 else{
  savedisksflag = true;
  System.Gadget.Settings.write ("SaveCitytoDisks", "true");
 }

  LocationIDCode = System.Gadget.Settings.read("LocationIDCode");
  if (LocationIDCode === ""){
   LocationIDCode = "EUR|UA|UP024|CHERKASY";
   System.Gadget.Settings.write("LocationIDCode", LocationIDCode);
  }

 icontype = System.Gadget.Settings.read("IconType");
 if (icontype == ""){
  icontype = "0";
  System.Gadget.Settings.write("IconType", icontype);
 }

 imperialsystemusaflag = System.Gadget.Settings.read ("ImperialSystemUSA");
 if (imperialsystemusaflag != "true"){
  imperialsystemusaflag = false;
  System.Gadget.Settings.write ("ImperialSystemUSA", "false");
 }
 else{
  imperialsystemusaflag = true;
  System.Gadget.Settings.write ("ImperialSystemUSA", "true");
 }

 temperatureformat = System.Gadget.Settings.read("TemperatureFormat");
 if (temperatureformat == ""){
  temperatureformat = "0";
  System.Gadget.Settings.write("TemperatureFormat", temperatureformat);
 }
 speedformat = System.Gadget.Settings.read("SpeedFormat");
 if (speedformat == ""){
  speedformat = "0";
  System.Gadget.Settings.write("SpeedFormat", speedformat);
 }
 pressureformat = System.Gadget.Settings.read("PressureFormat");
 if (pressureformat == ""){
  pressureformat = "0";
  System.Gadget.Settings.write("PressureFormat", pressureformat);
 }
 distanceformat = System.Gadget.Settings.read("DistanceFormat");
 if (distanceformat == ""){
  distanceformat = "0";
  System.Gadget.Settings.write("DistanceFormat", distanceformat);
 }
 timeformat = System.Gadget.Settings.read("TimeFormat");
 if (timeformat == ""){
  timeformat = "0";
  System.Gadget.Settings.write("TimeFormat", timeformat);
 }
 precformat = System.Gadget.Settings.read("PrecipitationFormat");
 if (precformat == ""){
  precformat = "0";
  System.Gadget.Settings.write("PrecipitationFormat", precformat);
 }
 dateformat = System.Gadget.Settings.read("DateFormat");
 if (dateformat == ""){
  dateformat = "0";
  System.Gadget.Settings.write("DateFormat", dateformat);
 }

 adjustlastupdtime = System.Gadget.Settings.read("AdjustLastUpdateTime");
 if (adjustlastupdtime == ""){
  adjustlastupdtime = "0";
  System.Gadget.Settings.write("AdjustLastUpdateTime", adjustlastupdtime);
 }
 adjustsuntime = System.Gadget.Settings.read("AdjustSunTime");
 if (adjustsuntime == ""){
  adjustsuntime = "0";
  System.Gadget.Settings.write("AdjustSunTime", adjustsuntime);
 }
 adjustastronomytime = System.Gadget.Settings.read("AdjustAstronomyTime");
 if (adjustastronomytime == ""){
  adjustastronomytime = "0";
  System.Gadget.Settings.write("AdjustAstronomyTime", adjustastronomytime);
 }

 size = System.Gadget.Settings.read("SetSize");
 if (size == ""){
  size = "1";
  System.Gadget.Settings.write("SetSize", size);
 }
 pixprefiks = size <= 1.2 ? "s" : "b";
 refreshRate = System.Gadget.Settings.read("refreshtime");
 if (refreshRate == ""){
  refreshRate = "1800000";
  System.Gadget.Settings.write("refreshtime", refreshRate);
 }
 autoscaleDPIflag = System.Gadget.Settings.read ("DPIautoscale");
 if (autoscaleDPIflag != "false"){
  autoscaleDPIflag = true;
  System.Gadget.Settings.write ("DPIautoscale", "true");
 }
 else{
  autoscaleDPIflag = false;
  System.Gadget.Settings.write ("DPIautoscale", "false");
 }
 autoupdateflag = System.Gadget.Settings.read ("AutoUpdate");
 if (autoupdateflag != "true"){
  autoupdateflag = false;
  System.Gadget.Settings.write ("AutoUpdate", "false");
 }
 else{
  autoupdateflag = true;
  System.Gadget.Settings.write ("AutoUpdate", "true");
 }

 waitforruntime = System.Gadget.Settings.read("WaitingTime");
 if (waitforruntime === ""){
  waitforruntime = 0;
  System.Gadget.Settings.write("WaitingTime", waitforruntime);
 }

 hidestateflag = System.Gadget.Settings.read ("StateHide");
 if (hidestateflag != "true"){
  hidestateflag = false;
  System.Gadget.Settings.write ("StateHide", "false");
 }
 else{
  hidestateflag = true;
  System.Gadget.Settings.write ("StateHide", "true");
 }

 hidetitleflag = System.Gadget.Settings.read ("TitleHide");
 if (hidetitleflag != "true"){
  hidetitleflag = false;
  System.Gadget.Settings.write ("TitleHide", "false");
 }
 else{
  hidetitleflag = true;
  System.Gadget.Settings.write ("TitleHide", "true");
 }

 hidelocationflag = System.Gadget.Settings.read ("LocationHide");
 if (hidelocationflag != "true"){
  hidelocationflag = false;
  System.Gadget.Settings.write ("LocationHide", "false");
 }
 else{
  hidelocationflag = true;
  System.Gadget.Settings.write ("LocationHide", "true");
 }

 hidepressureflag = System.Gadget.Settings.read ("PressureHide");
 if (hidepressureflag != "true"){
  hidepressureflag = false;
  System.Gadget.Settings.write ("PressureHide", "false");
 }
 else{
  hidepressureflag = true;
  System.Gadget.Settings.write ("PressureHide", "true");
 }

 hidehumidityflag = System.Gadget.Settings.read ("HumidityHide");
 if (hidehumidityflag != "true"){
  hidehumidityflag = false;
  System.Gadget.Settings.write ("HumidityHide", "false");
 }
 else{
  hidehumidityflag = true;
  System.Gadget.Settings.write ("HumidityHide", "true");
 }

 hidevisibilityflag = System.Gadget.Settings.read ("VisibilityHide");
 if (hidevisibilityflag != "true"){
  hidevisibilityflag = false;
  System.Gadget.Settings.write ("VisibilityHide", "false");
 }
 else{
  hidevisibilityflag = true;
  System.Gadget.Settings.write ("VisibilityHide", "true");
 }

 hideuvindexflag = System.Gadget.Settings.read ("UVindexHide");
 if (hideuvindexflag != "true"){
  hideuvindexflag = false;
  System.Gadget.Settings.write ("UVindexHide", "false");
 }
 else{
  hideuvindexflag = true;
  System.Gadget.Settings.write ("UVindexHide", "true");
 }

 hidewindflag = System.Gadget.Settings.read ("WindHide");
 if (hidewindflag != "true"){
  hidewindflag = false;
  System.Gadget.Settings.write ("WindHide", "false");
 }
 else{
  hidewindflag = true;
  System.Gadget.Settings.write ("WindHide", "true");
 }

 hideprecipitationflag = System.Gadget.Settings.read ("PrecipitationHide");
 if (hideprecipitationflag != "true"){
  hideprecipitationflag = false;
  System.Gadget.Settings.write ("PrecipitationHide", "false");
 }
 else{
  hideprecipitationflag = true;
  System.Gadget.Settings.write ("PrecipitationHide", "true");
 }

 hidesunflag = System.Gadget.Settings.read ("SunHide");
 if (hidesunflag != "true"){
  hidesunflag = false;
  System.Gadget.Settings.write ("SunHide", "false");
 }
 else{
  hidesunflag = true;
  System.Gadget.Settings.write ("SunHide", "true");
 }

 hidemoonflag = System.Gadget.Settings.read ("MoonHide");
 if (hidemoonflag != "true"){
  hidemoonflag = false;
  System.Gadget.Settings.write ("MoonHide", "false");
 }
 else{
  hidemoonflag = true;
  System.Gadget.Settings.write ("MoonHide", "true");
 }

 hideupdatedflag = System.Gadget.Settings.read ("UpdatedHide");
 if (hideupdatedflag != "true"){
  hideupdatedflag = false;
  System.Gadget.Settings.write ("UpdatedHide", "false");
 }
 else{
  hideupdatedflag = true;
  System.Gadget.Settings.write ("UpdatedHide", "true");
 }

 hidecopyrightflag = System.Gadget.Settings.read ("CopyrightHide");
 if (hidecopyrightflag != "true"){
  hidecopyrightflag = false;
  System.Gadget.Settings.write ("CopyrightHide", "false");
 }
 else{
  hidecopyrightflag = true;
  System.Gadget.Settings.write ("CopyrightHide", "true");
 }

 disableflyoutsoundsflag = System.Gadget.Settings.read ("DisableFlyoutSounds");
 if (disableflyoutsoundsflag != "true"){
  disableflyoutsoundsflag = false;
  System.Gadget.Settings.write ("DisableFlyoutSounds", "false");
 }
 else{
  disableflyoutsoundsflag = true;
  System.Gadget.Settings.write ("DisableFlyoutSounds", "true");
 }

 //color settings
 cBgColor = System.Gadget.Settings.read("colBgColor");
 if (cBgColor == ""){
  cBgColor = "#262526";
  System.Gadget.Settings.write("colBgColor", cBgColor);
 }
 cTitle = System.Gadget.Settings.read("colTitle");
 if (cTitle == ""){
  cTitle = "#FFFFFF";
  System.Gadget.Settings.write("colTitle", cTitle);
 }
 cTemperature = System.Gadget.Settings.read("colTemperature");
 if (cTemperature == ""){
  cTemperature = "#87CEFA";
  System.Gadget.Settings.write("colTemperature", cTemperature);
 }
 cLocation = System.Gadget.Settings.read("colLocation");
 if (cLocation == ""){
  cLocation = "#7EE444";
  System.Gadget.Settings.write("colLocation", cLocation);
 }
 cRealFeel = System.Gadget.Settings.read("colRealFeel");
 if (cRealFeel == ""){
  cRealFeel = "#CC6633";
  System.Gadget.Settings.write("colRealFeel", cRealFeel);
 }
 cPressure = System.Gadget.Settings.read("colPressure");
 if (cPressure == ""){
  cPressure = "#ED344D";
  System.Gadget.Settings.write("colPressure", cPressure);
 }
 cHumidity = System.Gadget.Settings.read("colHumidity");
 if (cHumidity == ""){
  cHumidity = "#00BFFF";
  System.Gadget.Settings.write("colHumidity", cHumidity);
 }
 cVisibility = System.Gadget.Settings.read("colVisibility");
 if (cVisibility == ""){
  cVisibility = "#33FF00";
  System.Gadget.Settings.write("colVisibility", cVisibility);
 }
 cUVindex = System.Gadget.Settings.read("colUVindex");
 if (cUVindex == ""){
  cUVindex = "#A2D8FC";
  System.Gadget.Settings.write("colUVindex", cUVindex);
 }
 cWind = System.Gadget.Settings.read("colWind");
 if (cWind == ""){
  cWind = "#BDFCEF";
  System.Gadget.Settings.write("colWind", cWind);
 }
 cPrecipitation = System.Gadget.Settings.read("colPrecipitation");
 if (cPrecipitation == ""){
  cPrecipitation = "#90EE90";
  System.Gadget.Settings.write("colPrecipitation", cPrecipitation);
 }
 cSunrise = System.Gadget.Settings.read("colSunrise");
 if (cSunrise == ""){
  cSunrise = "#FFF62F";
  System.Gadget.Settings.write("colSunrise", cSunrise);
 }
 cSunset = System.Gadget.Settings.read("colSunset");
 if (cSunset == ""){
  cSunset = "#EE6464";
  System.Gadget.Settings.write("colSunset", cSunset);
 }
 cMoonPhase = System.Gadget.Settings.read("colMoonPhase");
 if (cMoonPhase == ""){
  cMoonPhase = "#008000";
  System.Gadget.Settings.write("colMoonPhase", cMoonPhase);
 }
 cLastupdate = System.Gadget.Settings.read("colLastupdate");
 if (cLastupdate == ""){
  cLastupdate = "#C0C0C0";
  System.Gadget.Settings.write("colLastupdate", cLastupdate);
 }
 cLegend = System.Gadget.Settings.read("colLegend");
 if (cLegend == ""){
  cLegend = "#FFCC00";
  System.Gadget.Settings.write("colLegend", cLegend);
 }
 cError = System.Gadget.Settings.read("colError");
 if (cError == ""){
  cError = "#FF0000";
  System.Gadget.Settings.write("colError", cError);
 }
 cCopyright = System.Gadget.Settings.read("colCopyright");
 if (cCopyright == ""){
  cCopyright = "#00CCFF";
  System.Gadget.Settings.write("colCopyright", cCopyright);
 }
 cVersion = System.Gadget.Settings.read("colVersion");
 if (cVersion == ""){
  cVersion = "#C0C0C0";
  System.Gadget.Settings.write("colVersion", cVersion);
 }
 //color settings end
}

function setupgadget(){
 //fixed bug with 100% width BEFORE set real width in background section
 document.body.style.width = parseInt(130 * size);
 background.style.width = parseInt(130 * size);

 gtitle.style.display = "block";
 gline.style.display = "block";
 where.style.display = "block";
 pressure.style.display = "block";
 pressureval.style.display = "block";
 humidity.style.display = "block";
 humidityval.style.display = "block";
 visib.style.display = "block";
 visibval.style.display = "block";
 uvindextext.style.display = "block";
 uvindexval.style.display = "block";
 wind.style.display = "block";
 windval.style.display = "block";
 precipitation.style.display = "block";
 precipitationval.style.display = "block";
 sunrise.style.display = "block";
 sunriseval.style.display = "block";
 sunset.style.display = "block";
 sunsetval.style.display = "block";
 moonstr.style.display = "block";
 moonphase.style.display = "block";
 timeupd.style.display = "block";
 timeupdval.style.display = "block";
 autoapdater.style.display = "none";

 //top section
 gtitle.style.top = parseInt(6 * size);
 gline.style.top = parseInt(16 * size);
 curtemp.style.top = parseInt(24 * size);
 refreshicon.style.top = parseInt(26 * size);
 weathericon.style.top = parseInt(26 * size);
 error.style.top = parseInt(36 * size);
 waitforrunstr.style.top = parseInt(76 * size);
 techicons.style.top = size < 1.5 ? parseInt(43 * size) : parseInt(45 * size);
 realfeeltemp.style.top = parseInt(60 * size);
 where.style.top = parseInt(70 * size);
 pressure.style.top = parseInt(80 * size);
 pressureval.style.top = parseInt(80 * size);
 humidity.style.top = parseInt(90 * size);
 humidityval.style.top = parseInt(90 * size);
 visib.style.top = parseInt(100 * size);
 visibval.style.top = parseInt(100 * size);
 uvindextext.style.top = parseInt(110 * size);
 uvindexval.style.top = parseInt(110 * size);
 wind.style.top = parseInt(120* size);
 windval.style.top = parseInt(120* size);
 precipitation.style.top = parseInt(130 * size);
 precipitationval.style.top = parseInt(130 * size);
 sunrise.style.top = parseInt(140 * size);
 sunriseval.style.top = parseInt(140 * size);
 sunset.style.top = parseInt(150 * size);
 sunsetval.style.top = parseInt(150 * size);
 moonstr.style.top = parseInt(160 * size);
 moonphase.style.top = parseInt(160 * size);
 timeupd.style.top = parseInt(170 * size);
 timeupdval.style.top = parseInt(170 * size);
 advertis.style.top = parseInt(182 * size);
 versionnumber.style.top = parseInt(182 * size);

 //left section
 curtemp.style.left = parseInt(60 * size);
 refreshicon.style.left = parseInt(108 * size);
 weathericon.style.left = parseInt(5 * size);
 techicons.style.left = parseInt(56 * size);
 realfeeltemp.style.left = parseInt(55 * size);
 where.style.left = parseInt(6 * size);
 pressure.style.left = parseInt(7 * size);
 pressureval.style.left = parseInt(66 * size);
 humidity.style.left = parseInt(7 * size);
 humidityval.style.left = parseInt(66 * size);
 visib.style.left = parseInt(7 * size);
 visibval.style.left = parseInt(66 * size);
 uvindextext.style.left = parseInt(7 * size);
 uvindexval.style.left = parseInt(66 * size);
 wind.style.left = parseInt(7 * size);
 windval.style.left = parseInt(66 * size);
 precipitation.style.left = parseInt(7 * size);
 precipitationval.style.left = parseInt(66 * size);
 sunrise.style.left = parseInt(7 * size);
 sunriseval.style.left = parseInt(66 * size);
 sunset.style.left = parseInt(7 * size);
 sunsetval.style.left = parseInt(66 * size);
 moonstr.style.left = parseInt(7 * size);
 moonphase.style.left = parseInt(46 * size);
 timeupd.style.left = parseInt(7 * size);
 timeupdval.style.left = parseInt(56 * size);
 advertis.style.left = parseInt(8 * size);

 //font-size section
 gtitle.style.fontSize = parseInt(11 * size);
 curtemp.style.fontSize = parseInt(17 * size);
 realfeeltemp.style.fontSize = parseInt(9 * size);
 where.style.fontSize = parseInt(9 * size);
 pressure.style.fontSize = parseInt(9 * size);
 pressureval.style.fontSize = parseInt(9 * size);
 humidity.style.fontSize = parseInt(9 * size);
 humidityval.style.fontSize = parseInt(9 * size);
 visib.style.fontSize = parseInt(9 * size);
 visibval.style.fontSize = parseInt(9 * size);
 uvindextext.style.fontSize = parseInt(9 * size);
 uvindexval.style.fontSize = parseInt(9 * size);
 wind.style.fontSize = parseInt(9 * size);
 windval.style.fontSize = parseInt(9 * size);
 precipitation.style.fontSize = parseInt(9 * size);
 precipitationval.style.fontSize = parseInt(9 * size);
 sunrise.style.fontSize = parseInt(9 * size);
 sunriseval.style.fontSize = parseInt(9 * size);
 sunset.style.fontSize = parseInt(9 * size);
 sunsetval.style.fontSize = parseInt(9 * size);
 moonstr.style.fontSize = parseInt(9 * size);
 moonphase.style.fontSize = parseInt(9 * size);
 timeupd.style.fontSize = parseInt(9 * size);
 timeupdval.style.fontSize = parseInt(9 * size);
 error.style.fontSize = parseInt(12 * size);
 waitforrunstr.style.fontSize = parseInt(14 * size);
 advertis.style.fontSize = parseInt(10 * size);
 versionnumber.style.fontSize = parseInt(9 * size);
 autoapdater.style.fontSize = parseInt(9 * size);

 //width section
 where.style.width = parseInt(118 * size);
 versionnumber.style.width = parseInt(122 * size);

 //color settings
 gtitle.style.color = cTitle;
 curtemp.style.color = cTemperature;
 realfeeltemp.style.color = cLegend;
 realfeeltempval.style.color = cRealFeel;
 where.style.color = cLocation;
 pressure.style.color = cLegend;
 pressureval.style.color = cPressure;
 humidity.style.color = cLegend;
 humidityval.style.color = cHumidity;
 visib.style.color = cLegend;
 visibval.style.color = cVisibility;
 uvindextext.style.color = cLegend;
 uvindexval.style.color = cUVindex;
 wind.style.color = cLegend;
 windval.style.color = cWind;
 precipitation.style.color = cLegend;
 precipitationval.style.color = cPrecipitation;
 sunrise.style.color = cLegend;
 sunriseval.style.color = cSunrise;
 sunset.style.color = cLegend;
 sunsetval.style.color = cSunset;
 moonstr.style.color = cLegend;
 moonphase.style.color = cMoonPhase;
 timeupd.style.color = cLegend;
 timeupdval.style.color = cLastupdate;
 error.style.color = cError;
 waitforrunstr.style.color = cError;
 copyright.style.color = cCopyright;
 versionnumber.style.color = cVersion;

 //picture section
 wiconhere.style.width = parseInt(45 * size);
 wiconhere.style.height = parseInt(45 * size);
 refrimg.style.width = parseInt(16 * size);
 refrimg.style.height = parseInt(16 * size);
 refrimg.src = "images/refresh" + pixprefiks + ".png";
 refrershimg.style.width = parseInt(16 * size);
 refrershimg.style.height = parseInt(16 * size);
 refrershimg.src = "images/refresh" + pixprefiks + ".png";
 foreimg.style.width = parseInt(16 * size);
 foreimg.style.height = parseInt(16 * size);
 foreimg.src = "images/forecast" + pixprefiks + ".png";
 astronimg.style.width = parseInt(16 * size);
 astronimg.style.height = parseInt(16 * size);
 astronimg.src = "images/solarsystem" + pixprefiks + ".png";
 gsimg.style.width = parseInt(16 * size);
 gsimg.style.height = parseInt(16 * size);
 gsimg.src = "images/gstorm" + pixprefiks +".png";
 noconnectimg.style.width = parseInt(14 * size);
 noconnectimg.style.height = parseInt(14 * size);
 noconnectimg.src = "images/noconnect" + pixprefiks +".png";

 var k;
 factheight = 202;

 if (hidetitleflag){
  //title
  gtitle.style.display = "none";
  gline.style.display = "none";

  k=curtemp.style.top;
  curtemp.style.top = parseInt(k)-parseInt(20 * size);
  k=refreshicon.style.top;
  refreshicon.style.top = parseInt(k)-parseInt(20 * size);
  k=weathericon.style.top;
  weathericon.style.top = parseInt(k)-parseInt(20 * size);
  k=techicons.style.top;
  techicons.style.top = parseInt(k)-parseInt(20 * size);
  k=realfeeltemp.style.top;
  realfeeltemp.style.top = parseInt(k)-parseInt(20 * size);
  k=where.style.top;
  where.style.top = parseInt(k)-parseInt(20 * size);
  k=pressure.style.top;
  pressure.style.top = parseInt(k)-parseInt(20 * size);
  k=pressureval.style.top;
  pressureval.style.top = parseInt(k)-parseInt(20 * size);
  k=humidity.style.top;
  humidity.style.top = parseInt(k)-parseInt(20 * size);
  k=humidityval.style.top;
  humidityval.style.top = parseInt(k)-parseInt(20 * size);
  k=visib.style.top;
  visib.style.top = parseInt(k)-parseInt(20 * size);
  k=visibval.style.top;
  visibval.style.top = parseInt(k)-parseInt(20 * size);
  k=uvindextext.style.top;
  uvindextext.style.top = parseInt(k)-parseInt(20 * size);
  k=uvindexval.style.top;
  uvindexval.style.top = parseInt(k)-parseInt(20 * size);
  k=wind.style.top;
  wind.style.top = parseInt(k)-parseInt(20 * size);
  k=windval.style.top;
  windval.style.top = parseInt(k)-parseInt(20 * size);
  k=precipitation.style.top;
  precipitation.style.top = parseInt(k)-parseInt(20 * size);
  k=precipitationval.style.top;
  precipitationval.style.top = parseInt(k)-parseInt(20 * size);
  k=sunrise.style.top;
  sunrise.style.top = parseInt(k)-parseInt(20 * size);
  k=sunriseval.style.top;
  sunriseval.style.top = parseInt(k)-parseInt(20 * size);
  k=sunset.style.top;
  sunset.style.top = parseInt(k)-parseInt(20 * size);
  k=sunsetval.style.top;
  sunsetval.style.top = parseInt(k)-parseInt(20 * size);
  k=moonstr.style.top;
  moonstr.style.top = parseInt(k)-parseInt(20 * size);
  k=moonphase.style.top;
  moonphase.style.top = parseInt(k)-parseInt(20 * size);
  k=timeupd.style.top;
  timeupd.style.top = parseInt(k)-parseInt(20 * size);
  k=timeupdval.style.top;
  timeupdval.style.top = parseInt(k)-parseInt(20 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(20 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(20 * size);

  factheight -= 20;
 }

 if (hidelocationflag){
  //where
  where.style.display = "none";

  k=pressure.style.top;
  pressure.style.top = parseInt(k)-parseInt(10 * size);
  k=pressureval.style.top;
  pressureval.style.top = parseInt(k)-parseInt(10 * size);
  k=humidity.style.top;
  humidity.style.top = parseInt(k)-parseInt(10 * size);
  k=humidityval.style.top;
  humidityval.style.top = parseInt(k)-parseInt(10 * size);
  k=visib.style.top;
  visib.style.top = parseInt(k)-parseInt(10 * size);
  k=visibval.style.top;
  visibval.style.top = parseInt(k)-parseInt(10 * size);
  k=uvindextext.style.top;
  uvindextext.style.top = parseInt(k)-parseInt(10 * size);
  k=uvindexval.style.top;
  uvindexval.style.top = parseInt(k)-parseInt(10 * size);
  k=wind.style.top;
  wind.style.top = parseInt(k)-parseInt(10 * size);
  k=windval.style.top;
  windval.style.top = parseInt(k)-parseInt(10 * size);
  k=precipitation.style.top;
  precipitation.style.top = parseInt(k)-parseInt(10 * size);
  k=precipitationval.style.top;
  precipitationval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunrise.style.top;
  sunrise.style.top = parseInt(k)-parseInt(10 * size);
  k=sunriseval.style.top;
  sunriseval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunset.style.top;
  sunset.style.top = parseInt(k)-parseInt(10 * size);
  k=sunsetval.style.top;
  sunsetval.style.top = parseInt(k)-parseInt(10 * size);
  k=moonstr.style.top;
  moonstr.style.top = parseInt(k)-parseInt(10 * size);
  k=moonphase.style.top;
  moonphase.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupd.style.top;
  timeupd.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupdval.style.top;
  timeupdval.style.top = parseInt(k)-parseInt(10 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(10 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(10 * size);

  factheight -= 10;
 }

 if (hidepressureflag){
  //Pressure
  pressure.style.display = "none";
  pressureval.style.display = "none";

  k=humidity.style.top;
  humidity.style.top = parseInt(k)-parseInt(10 * size);
  k=humidityval.style.top;
  humidityval.style.top = parseInt(k)-parseInt(10 * size);
  k=visib.style.top;
  visib.style.top = parseInt(k)-parseInt(10 * size);
  k=visibval.style.top;
  visibval.style.top = parseInt(k)-parseInt(10 * size);
  k=uvindextext.style.top;
  uvindextext.style.top = parseInt(k)-parseInt(10 * size);
  k=uvindexval.style.top;
  uvindexval.style.top = parseInt(k)-parseInt(10 * size);
  k=wind.style.top;
  wind.style.top = parseInt(k)-parseInt(10 * size);
  k=windval.style.top;
  windval.style.top = parseInt(k)-parseInt(10 * size);
  k=precipitation.style.top;
  precipitation.style.top = parseInt(k)-parseInt(10 * size);
  k=precipitationval.style.top;
  precipitationval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunrise.style.top;
  sunrise.style.top = parseInt(k)-parseInt(10 * size);
  k=sunriseval.style.top;
  sunriseval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunset.style.top;
  sunset.style.top = parseInt(k)-parseInt(10 * size);
  k=sunsetval.style.top;
  sunsetval.style.top = parseInt(k)-parseInt(10 * size);
  k=moonstr.style.top;
  moonstr.style.top = parseInt(k)-parseInt(10 * size);
  k=moonphase.style.top;
  moonphase.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupd.style.top;
  timeupd.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupdval.style.top;
  timeupdval.style.top = parseInt(k)-parseInt(10 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(10 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(10 * size);

  factheight -= 10;
 }

 if (hidehumidityflag){
  //Humidity
  humidity.style.display = "none";
  humidityval.style.display = "none";

  k=visib.style.top;
  visib.style.top = parseInt(k)-parseInt(10 * size);
  k=visibval.style.top;
  visibval.style.top = parseInt(k)-parseInt(10 * size);
  k=uvindextext.style.top;
  uvindextext.style.top = parseInt(k)-parseInt(10 * size);
  k=uvindexval.style.top;
  uvindexval.style.top = parseInt(k)-parseInt(10 * size);
  k=wind.style.top;
  wind.style.top = parseInt(k)-parseInt(10 * size);
  k=windval.style.top;
  windval.style.top = parseInt(k)-parseInt(10 * size);
  k=precipitation.style.top;
  precipitation.style.top = parseInt(k)-parseInt(10 * size);
  k=precipitationval.style.top;
  precipitationval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunrise.style.top;
  sunrise.style.top = parseInt(k)-parseInt(10 * size);
  k=sunriseval.style.top;
  sunriseval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunset.style.top;
  sunset.style.top = parseInt(k)-parseInt(10 * size);
  k=sunsetval.style.top;
  sunsetval.style.top = parseInt(k)-parseInt(10 * size);
  k=moonstr.style.top;
  moonstr.style.top = parseInt(k)-parseInt(10 * size);
  k=moonphase.style.top;
  moonphase.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupd.style.top;
  timeupd.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupdval.style.top;
  timeupdval.style.top = parseInt(k)-parseInt(10 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(10 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(10 * size);

  factheight -= 10;
 }

 if (hidevisibilityflag){
  //Visibility
  visib.style.display = "none";
  visibval.style.display = "none";

  k=uvindextext.style.top;
  uvindextext.style.top = parseInt(k)-parseInt(10 * size);
  k=uvindexval.style.top;
  uvindexval.style.top = parseInt(k)-parseInt(10 * size);
  k=wind.style.top;
  wind.style.top = parseInt(k)-parseInt(10 * size);
  k=windval.style.top;
  windval.style.top = parseInt(k)-parseInt(10 * size);
  k=precipitation.style.top;
  precipitation.style.top = parseInt(k)-parseInt(10 * size);
  k=precipitationval.style.top;
  precipitationval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunrise.style.top;
  sunrise.style.top = parseInt(k)-parseInt(10 * size);
  k=sunriseval.style.top;
  sunriseval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunset.style.top;
  sunset.style.top = parseInt(k)-parseInt(10 * size);
  k=sunsetval.style.top;
  sunsetval.style.top = parseInt(k)-parseInt(10 * size);
  k=moonstr.style.top;
  moonstr.style.top = parseInt(k)-parseInt(10 * size);
  k=moonphase.style.top;
  moonphase.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupd.style.top;
  timeupd.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupdval.style.top;
  timeupdval.style.top = parseInt(k)-parseInt(10 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(10 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(10 * size);

  factheight -= 10;
 }

 if (hideuvindexflag){
  //UV index
  uvindextext.style.display = "none";
  uvindexval.style.display = "none";

  k=wind.style.top;
  wind.style.top = parseInt(k)-parseInt(10 * size);
  k=windval.style.top;
  windval.style.top = parseInt(k)-parseInt(10 * size);
  k=precipitation.style.top;
  precipitation.style.top = parseInt(k)-parseInt(10 * size);
  k=precipitationval.style.top;
  precipitationval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunrise.style.top;
  sunrise.style.top = parseInt(k)-parseInt(10 * size);
  k=sunriseval.style.top;
  sunriseval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunset.style.top;
  sunset.style.top = parseInt(k)-parseInt(10 * size);
  k=sunsetval.style.top;
  sunsetval.style.top = parseInt(k)-parseInt(10 * size);
  k=moonstr.style.top;
  moonstr.style.top = parseInt(k)-parseInt(10 * size);
  k=moonphase.style.top;
  moonphase.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupd.style.top;
  timeupd.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupdval.style.top;
  timeupdval.style.top = parseInt(k)-parseInt(10 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(10 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(10 * size);

  factheight -= 10;
 }

 if (hidewindflag){
  //Wind
  wind.style.display = "none";
  windval.style.display = "none";

  k=precipitation.style.top;
  precipitation.style.top = parseInt(k)-parseInt(10 * size);
  k=precipitationval.style.top;
  precipitationval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunrise.style.top;
  sunrise.style.top = parseInt(k)-parseInt(10 * size);
  k=sunriseval.style.top;
  sunriseval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunset.style.top;
  sunset.style.top = parseInt(k)-parseInt(10 * size);
  k=sunsetval.style.top;
  sunsetval.style.top = parseInt(k)-parseInt(10 * size);
  k=moonstr.style.top;
  moonstr.style.top = parseInt(k)-parseInt(10 * size);
  k=moonphase.style.top;
  moonphase.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupd.style.top;
  timeupd.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupdval.style.top;
  timeupdval.style.top = parseInt(k)-parseInt(10 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(10 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(10 * size);

  factheight -= 10;
 }

 if (hideprecipitationflag){
  //Precipitation
  precipitation.style.display = "none";
  precipitationval.style.display = "none";

  k=sunrise.style.top;
  sunrise.style.top = parseInt(k)-parseInt(10 * size);
  k=sunriseval.style.top;
  sunriseval.style.top = parseInt(k)-parseInt(10 * size);
  k=sunset.style.top;
  sunset.style.top = parseInt(k)-parseInt(10 * size);
  k=sunsetval.style.top;
  sunsetval.style.top = parseInt(k)-parseInt(10 * size);
  k=moonstr.style.top;
  moonstr.style.top = parseInt(k)-parseInt(10 * size);
  k=moonphase.style.top;
  moonphase.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupd.style.top;
  timeupd.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupdval.style.top;
  timeupdval.style.top = parseInt(k)-parseInt(10 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(10 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(10 * size);

  factheight -= 10;
 }

 if (hidesunflag){
  //Sunrise/Sunset
  sunrise.style.display = "none";
  sunriseval.style.display = "none";
  sunset.style.display = "none";
  sunsetval.style.display = "none";

  k=moonstr.style.top;
  moonstr.style.top = parseInt(k)-parseInt(20 * size);
  k=moonphase.style.top;
  moonphase.style.top = parseInt(k)-parseInt(20 * size);
  k=timeupd.style.top;
  timeupd.style.top = parseInt(k)-parseInt(20 * size);
  k=timeupdval.style.top;
  timeupdval.style.top = parseInt(k)-parseInt(20 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(20 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(20 * size);

  factheight -= 20;
 }

 if (hidemoonflag){
  //Moon
  moonstr.style.display = "none";
  moonphase.style.display = "none";

  k=timeupd.style.top;
  timeupd.style.top = parseInt(k)-parseInt(10 * size);
  k=timeupdval.style.top;
  timeupdval.style.top = parseInt(k)-parseInt(10 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(10 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(10 * size);

  factheight -= 10;
 }

 if (hideupdatedflag){
  //Updated at
  timeupd.style.display = "none";
  timeupdval.style.display = "none";

  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(10 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(10 * size);

  factheight -= 10;
 }

 if (hidecopyrightflag){
  //copyright
  advertis.style.display = "none";
  versionnumber.style.display = "none";
  factheight -= 12;
 }
 else{
  advertis.style.display = "block";
  versionnumber.style.display = "block";
 }

 //background section
 document.body.style.height = parseInt(factheight * size);
 background.style.height = parseInt(factheight * size);

 mainsquare.style.top = parseInt(5 * size); 
 mainsquare.style.left = parseInt(5 * size);  
 mainsquare.style.width =  parseInt((130 - 10) * size);
 mainsquare.style.height = parseInt((factheight - 10) * size);
 mainsquare.style.background = cBgColor;
}

function refresh(){
 clearTimeout(timervar);
 w10err = 0; //Important
 firstconnectflag = true; //Important
 getweather();
}

function adjustclockfordaylightsavingstime(t,adjusttime){
 if (adjusttime == 0) return t;
 t = t.split(':');
 t[0] = Number(t[0]);
 t[0] += adjusttime;
 if (t[0] < 0) t[0] = 23;
 else if (t[0] > 23) t[0] = 0;
 return t[0] + ":" + t[1];
}

function convertto12time(t){
 t = t.split(':');
 var ampm = "AM";
 if (t[0] >= 12){
  ampm = "PM";
  t[0] -= 12;
 }
 if (t[0] == "00" || t[0] == "0") t[0] = 12;
 return (Number(t[0]) + ":" + t[1] + " " + ampm);
}

function getweather(){
 var max_id = setTimeout(function () {});
 while (max_id--){
  clearTimeout(max_id);
 }

 readweatherdata();

 timervar = setTimeout("getweather()",refreshRate);
}

function readweatherdata(){
 var URL = "http://forecastfox.accuweather.com/adcbin/forecastfox/weather_data.asp?&partner=forecastfox&par=" + Math.round(Math.random()*10000) +
 "&location=" + LocationIDCode + (!imperialsystemusaflag ? "&metric=1" : "");
 xmlHttp.open("GET", URL, false); //true mean call is asynchronous
 xmlHttp.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
 xmlHttp.onreadystatechange = getweatherData;
 xmlHttp.send(null);
}

function getweatherData(){
 localstring.style.display = "inline";
 noconnectimg.style.display = "none";
 if (xmlHttp.readyState == 4){
  if (xmlHttp.status == 200){
   parseweatherdata(xmlHttp.responseXML);
   firstconnectflag = false;
  }
  else{
   if (!firstconnectflag){
    if (!hideupdatedflag){
     localstring.style.display = "none";
     noconnectimg.style.display = "inline";
    }
   }
   else{
    switch (xmlHttp.status){
     case 404:
      errormsg.innerHTML = "Unfortunately<br>weather data<br>not found :(<br>Wait a minute<br>and press refresh<br>icon below.";
      break;

     case 12029:
      errormsg.innerHTML = "Unfortunately<br>weather site<br>is not respond.<br>Wait a minute<br>and press refresh<br>icon below.";
      break;

     case 12002:
     case 12007:
     case 12030:
     case 12031:
      errormsg.innerHTML = "No connection.<br>Please, connect<br>to Internet<br>and press refresh<br>icon below.";
      break;

     default:
      errormsg.innerHTML = "Something<br>went wrong.<br>Error " + xmlHttp.status + "<br>Try press refresh<br>icon below.";
      break;
    }//switch
    hideifnoconnect.style.display = "none";
    error.style.display = "block";

    timervar = setTimeout("getweather()",refreshRate);
   }//else
  }//else readyState == 200
 }//readyState == 4
}

function parseweatherdata(weather){
 var str_LastUpdate = lastupdatetime.innerText;
 try{
  var city = weather.getElementsByTagName("city")[0].firstChild.nodeValue;
  var state = weather.getElementsByTagName("state")[0].firstChild.nodeValue;
  where.title = state;
  state = state.replace(" United States", ", US").replace(city + " ", "");
  where.innerText = !hidestateflag ? city + ", " + state : city;
  var add = "";
  var d = weather.getElementsByTagName("pressure")[0].attributes[0].nodeValue;
  if (d == "Rising") add = " ↑";
  else if (d == "Decreasing") add = " ↓";
  if (!imperialsystemusaflag){
   switch (pressureformat){
    case 1:
     pressureval.innerText = (weather.getElementsByTagName("pressure")[0].firstChild.nodeValue * 7.5006375541921).toFixed(0) + " mmHg" + add;
     break;

    case 2:
     pressureval.innerText = (weather.getElementsByTagName("pressure")[0].firstChild.nodeValue * 0.2952998751).toFixed(2) + " inHg" + add;

     break;
 
    case 3:
     pressureval.innerText = weather.getElementsByTagName("pressure")[0].firstChild.nodeValue * 10 + " mbar" + add;
     break;

    default:
     pressureval.innerText = weather.getElementsByTagName("pressure")[0].firstChild.nodeValue * 10 + " hPa" + add;
     break;
   }
   curtemp.innerText = (temperatureformat == 0) ? weather.getElementsByTagName("temperature")[0].firstChild.nodeValue + "°C" : (weather.getElementsByTagName("temperature")[0].firstChild.nodeValue*(9/5)+32).toFixed(0) + "°F";
   realfeeltempval.innerText = (temperatureformat == 0) ? weather.getElementsByTagName("realfeel")[0].firstChild.nodeValue + "°C" : (weather.getElementsByTagName("realfeel")[0].firstChild.nodeValue*(9/5)+32).toFixed(0) + "°F";
   visibval.innerText = (distanceformat == 0) ? weather.getElementsByTagName("visibility")[0].firstChild.nodeValue + " km" : (weather.getElementsByTagName("visibility")[0].firstChild.nodeValue*0.621371192).toFixed(1) + " mi";
   switch (speedformat){
    case 1:
     windval.innerText = (weather.getElementsByTagName("windspeed")[0].firstChild.nodeValue * 3.6).toFixed(0) + " km/h " +
     weather.getElementsByTagName("winddirection")[0].firstChild.nodeValue;
     break;

    case 2:
     windval.innerText = (weather.getElementsByTagName("windspeed")[0].firstChild.nodeValue * 2.23693629).toFixed(0) + " mph " +
     weather.getElementsByTagName("winddirection")[0].firstChild.nodeValue;
     break;
 
    default:
     windval.innerText = weather.getElementsByTagName("windspeed")[0].firstChild.nodeValue + " m/s " +
     weather.getElementsByTagName("winddirection")[0].firstChild.nodeValue;
     break;
   }
   precipitationval.innerText = (precformat == 0) ? weather.getElementsByTagName("precip")[0].firstChild.nodeValue + " mm" : 
  (!isNaN(weather.getElementsByTagName("precip")[0].firstChild.nodeValue) ? (weather.getElementsByTagName("precip")[0].firstChild.nodeValue*0.039370078740157).toFixed(2) :
   weather.getElementsByTagName("precip")[0].firstChild.nodeValue) + " in";
  }
  else{
   switch (pressureformat){
    case 1:
     pressureval.innerText = (weather.getElementsByTagName("pressure")[0].firstChild.nodeValue * 25.399999704976).toFixed(0) + " mmHg" + add;
     break;

    case 2:
     pressureval.innerText = weather.getElementsByTagName("pressure")[0].firstChild.nodeValue + " inHg" + add;
     break;
 
    case 3:
     pressureval.innerText = (weather.getElementsByTagName("pressure")[0].firstChild.nodeValue * 33.863886666667).toFixed(0) + " mbar" + add;
     break;

    default:
     pressureval.innerText = (weather.getElementsByTagName("pressure")[0].firstChild.nodeValue * 33.863886666667).toFixed(0) + " hPa" + add;
     break;
   }
   curtemp.innerText = (temperatureformat == 0) ? ((5/9)*(weather.getElementsByTagName("temperature")[0].firstChild.nodeValue-32)).toFixed(0) + "°C" : weather.getElementsByTagName("temperature")[0].firstChild.nodeValue + "°F";
   realfeeltempval.innerText = (temperatureformat == 0) ? ((5/9)*(weather.getElementsByTagName("realfeel")[0].firstChild.nodeValue-32)).toFixed(0) + "°C" : weather.getElementsByTagName("realfeel")[0].firstChild.nodeValue + "°F";
   visibval.innerText = (distanceformat == 0) ? (weather.getElementsByTagName("visibility")[0].firstChild.nodeValue*1.609344).toFixed(0) + " km" : weather.getElementsByTagName("visibility")[0].firstChild.nodeValue + " mi";
   switch (speedformat){
    case 1:
     windval.innerText = (weather.getElementsByTagName("windspeed")[0].firstChild.nodeValue * 1.609344).toFixed(0) + " km/h " +
     weather.getElementsByTagName("winddirection")[0].firstChild.nodeValue;
     break;

    case 2:
     windval.innerText = weather.getElementsByTagName("windspeed")[0].firstChild.nodeValue + " mph " +
     weather.getElementsByTagName("winddirection")[0].firstChild.nodeValue;
     break;
 
    default:
     windval.innerText = (weather.getElementsByTagName("windspeed")[0].firstChild.nodeValue * 0.44704).toFixed(0) + " m/s " +
     weather.getElementsByTagName("winddirection")[0].firstChild.nodeValue;
     break;
   }
   precipitationval.innerText = (precformat == 0) ? (weather.getElementsByTagName("precip")[0].firstChild.nodeValue * 25.4).toFixed(1) + " mm" : weather.getElementsByTagName("precip")[0].firstChild.nodeValue + " in";
  }
 
  humidityval.innerText = weather.getElementsByTagName("humidity")[0].firstChild.nodeValue;
  weathericon.title = weather.getElementsByTagName("weathertext")[0].firstChild.nodeValue;
  wiconhere.src = "images/main/" + weather.getElementsByTagName("weathericon")[0].firstChild.nodeValue + pixprefiks + ".png";
  uvindexval.innerText = weather.getElementsByTagName("uvindex")[0].attributes[0].nodeValue + " " + weather.getElementsByTagName("uvindex")[0].firstChild.nodeValue;
  var e = weather.getElementsByTagName("sun")[0].attributes[1].nodeValue.split(":");
  var s = weather.getElementsByTagName("sun")[0].attributes[0].nodeValue.split(":");
  var dd = (e[0]*3600 + e[1]*60) - (s[0]*3600 + s[1]*60);
  daylength.title = "Day Length: " + Math.floor(dd/3600) + "h " + Math.floor((dd%3600)/60) + "m";
  sunriseval.innerText = (timeformat == 0) ? adjustclockfordaylightsavingstime(weather.getElementsByTagName("sun")[0].attributes[0].nodeValue,adjustsuntime) : convertto12time(adjustclockfordaylightsavingstime(weather.getElementsByTagName("sun")[0].attributes[0].nodeValue,adjustsuntime));
  sunsetval.innerText = (timeformat == 0) ? adjustclockfordaylightsavingstime(weather.getElementsByTagName("sun")[0].attributes[1].nodeValue,adjustsuntime) : convertto12time(adjustclockfordaylightsavingstime(weather.getElementsByTagName("sun")[0].attributes[1].nodeValue,adjustsuntime));
  moonphase.innerText = getmoonphase();
  lastupdatetime.innerText = (timeformat == 0) ? adjustclockfordaylightsavingstime(weather.getElementsByTagName("time")[0].firstChild.nodeValue,adjustlastupdtime) : convertto12time(adjustclockfordaylightsavingstime(weather.getElementsByTagName("time")[0].firstChild.nodeValue,adjustlastupdtime));
  //astronomy
  astronomy[0] = new Array;
  astronomy[0][0] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("sun")[0].getAttribute("rise"),adjustastronomytime);
  astronomy[0][1] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("sun")[0].getAttribute("set"),adjustastronomytime);
  astronomy[1] = new Array;
  astronomy[1][0] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("moon")[0].getAttribute("rise"),adjustastronomytime);
  astronomy[1][1] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("moon")[0].getAttribute("set"),adjustastronomytime);
  astronomy[2] = new Array;
  astronomy[2][0] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("mercury")[0].getAttribute("rise"),adjustastronomytime);
  astronomy[2][1] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("mercury")[0].getAttribute("set"),adjustastronomytime);
  astronomy[3] = new Array;
  astronomy[3][0] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("venus")[0].getAttribute("rise"),adjustastronomytime);
  astronomy[3][1] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("venus")[0].getAttribute("set"),adjustastronomytime);
  astronomy[4] = new Array;
  astronomy[4][0] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("mars")[0].getAttribute("rise"),adjustastronomytime);
  astronomy[4][1] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("mars")[0].getAttribute("set"),adjustastronomytime);
  astronomy[5] = new Array;
  astronomy[5][0] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("jupiter")[0].getAttribute("rise"),adjustastronomytime);
  astronomy[5][1] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("jupiter")[0].getAttribute("set"),adjustastronomytime);
  astronomy[6] = new Array;
  astronomy[6][0] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("saturn")[0].getAttribute("rise"),adjustastronomytime);
  astronomy[6][1] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("saturn")[0].getAttribute("set"),adjustastronomytime);
  astronomy[7] = new Array;
  astronomy[7][0] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("uranus")[0].getAttribute("rise"),adjustastronomytime);
  astronomy[7][1] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("uranus")[0].getAttribute("set"),adjustastronomytime);
  astronomy[8] = new Array;
  astronomy[8][0] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("neptune")[0].getAttribute("rise"),adjustastronomytime);
  astronomy[8][1] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("neptune")[0].getAttribute("set"),adjustastronomytime);
  astronomy[9] = new Array;
  astronomy[9][0] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("pluto")[0].getAttribute("rise"),adjustastronomytime);
  astronomy[9][1] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("planets")[0].getElementsByTagName("pluto")[0].getAttribute("set"),adjustastronomytime);
  //forecast
  for (var i=0;i<9;i++){
   obsdate[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("obsdate")[0].firstChild.nodeValue;
   daycode[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("daycode")[0].firstChild.nodeValue;
   fsunrise[i] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("day")[i].getElementsByTagName("sunrise")[0].firstChild.nodeValue,adjustsuntime);
   fsunset[i] = adjustclockfordaylightsavingstime(weather.getElementsByTagName("day")[i].getElementsByTagName("sunset")[0].firstChild.nodeValue,adjustsuntime);
   dtext[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("txtshort")[0].firstChild.nodeValue;
   dwicon[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("weathericon")[0].firstChild.nodeValue;
   dhtemp[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("hightemperature")[0].firstChild.nodeValue;
   dltemp[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("lowtemperature")[0].firstChild.nodeValue;
   dhrftemp[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("realfeelhigh")[0].firstChild.nodeValue;
   dlrftemp[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("realfeellow")[0].firstChild.nodeValue;
   dwindspd[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("windspeed")[0].firstChild.nodeValue;
   dwinddir[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("winddirection")[0].firstChild.nodeValue;
   dmaxuv[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("maxuv")[0].firstChild.nodeValue;
   ntext[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("txtshort")[1].firstChild.nodeValue;
   nwicon[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("weathericon")[1].firstChild.nodeValue;
   nhtemp[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("hightemperature")[1].firstChild.nodeValue;
   nltemp[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("lowtemperature")[1].firstChild.nodeValue;
   nhrftemp[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("realfeelhigh")[1].firstChild.nodeValue;
   nlrftemp[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("realfeellow")[1].firstChild.nodeValue;
   nwindspd[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("windspeed")[1].firstChild.nodeValue;
   nwinddir[i] = weather.getElementsByTagName("day")[i].getElementsByTagName("winddirection")[1].firstChild.nodeValue;
  }
  error.style.display = "none";
  hideifnoconnect.style.display = "block";
  w10err = 0;
 }//try
 catch (e){
  clearTimeout(timervar);
  if (w10err <= 3){
   w10err++;
   var tmptimer = setTimeout("readweatherdata()",1000);
  }
  else{
   if (int_Counter <= 3){
	int_Counter++;
    var tmptimer = setTimeout("readweatherdata()",1000);
   	error.style.display = "none";
   	hideifnoconnect.style.display = "block";
   }
   else{
	errormsg.innerHTML = "Something<br>went wrong.<br><br>Try pressing the refresh<br>icon below.";
	hideifnoconnect.style.display = "none";
   	error.style.display = "block";
   }
   w10err = 0;
  }
 }
 if (str_LastUpdate != lastupdatetime.innerText) int_Counter = 0;

 timervar = setTimeout("getweather()",refreshRate);
}

function getmoonphase(){
 var today = new Date();
 var Year = today.getFullYear();
 var Month = today.getMonth();
 var Day = today.getDate();
 // Variable names used: J, K1, K2, K3, MM, V, YY
 var YY = Year - parseInt((12 - Month)/10);
 var MM = Month + 9;
 if (MM >= 12) MM -= 12;
 var K1 = parseInt(365.25 * (YY + 4712));
 var K2 = parseInt(30.6 * MM + .5);
 var K3 = parseInt(parseInt((YY/100) + 49) * .75) - 38;
 // J is the Julian date at 12h UT on day in question
 var J = K1 + K2 + Day + 59;
 // Adjust for Gregorian calendar, if applicable
 if (J > 2299160) J -= K3;
 // Calculate illumination (synodic) phase
 var V = (J - 2451550.1)/29.530588853;
 V = V - parseInt(V);
 // Normalize values to range from 0 to 1
 if (V < 0) V = V + 1;
 // Moon's age in days from New Moon
 var AG = V * 29.53;

 var Phase;
 if (AG <= 1.8456618033125) Phase = "New";
 else if (AG <= 5.5369854099375) Phase = "Waxing Crescent";
 else if (AG <= 9.2283090165625) Phase = "First Quarter";
 else if (AG <= 12.9196326231875) Phase = "Waxing Gibbous";
 else if (AG <= 16.6109562298125) Phase = "Full";
 else if (AG <= 20.3022798364375) Phase = "Waning Gibbous";
 else if (AG <= 23.9936034430625) Phase = "Last Quarter";
 else if (AG <= 27.6849270496875) Phase = "Waning Crescent";
 else Phase = "New";
 return Phase;
}

function showFlyout(i){
 System.Gadget.Flyout.file = (i==1) ? "WeatherForecast.html" : ((i == 2) ? "Astronomy.html" : "GeomagneticStorms.html");

 if (!System.Gadget.Flyout.show){
  System.Gadget.Flyout.show = true;
  if (!disableflyoutsoundsflag) System.Sound.playSound("media/service.wav");
 }
 else System.Gadget.Flyout.show = false;
}